﻿' Note: Set the Canvas's Background property to Brushes.White at design time.
Class Window1
    Private start_point As Point
    Private new_rectangle As Rectangle = Nothing

    ' Start the new Rectangle.
    Private Sub canRectangle_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canRectangle.MouseLeftButtonDown
        new_rectangle = New Rectangle()
        new_rectangle.Stroke = Brushes.Purple
        new_rectangle.Fill = Brushes.Green
        new_rectangle.Width = 0
        new_rectangle.Height = 0

        start_point = e.GetPosition(canRectangle)
        Canvas.SetTop(new_rectangle, start_point.Y)
        Canvas.SetLeft(new_rectangle, start_point.X)

        canRectangle.Children.Add(new_rectangle)
    End Sub

    ' Change the Rectangle's size.
    Private Sub canRectangle_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles canRectangle.MouseMove
        If new_rectangle IsNot Nothing Then
            Dim pt As Point = e.GetPosition(canRectangle)

            Canvas.SetTop(new_rectangle, Math.Min(pt.Y, start_point.Y))
            Canvas.SetLeft(new_rectangle, Math.Min(pt.X, start_point.X))
            new_rectangle.Width = Math.Abs(pt.X - start_point.X)
            new_rectangle.Height = Math.Abs(pt.Y - start_point.Y)
        End If
    End Sub

    ' Finish the Rectangle.
    Private Sub canRectangle_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles canRectangle.MouseLeftButtonUp
        new_rectangle = Nothing
    End Sub
End Class
